<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
if ( ! class_exists( 'Penci_Social_Counter_Facebook_API' ) ):
	class Penci_Social_Counter_Facebook_API {
		public static function get_count( $data, $cache_period ) {

			$page_id        = preg_replace( '/\s+/', '', $data['name'] );
			$facebook_count = get_transient( 'penci_counter_facebook' . $page_id );

			if ( ! $facebook_count && $page_id ) {
				$get_request = wp_remote_get( "https://www.facebook.com/plugins/likebox.php?href=https://facebook.com/$page_id&show_faces=true&header=false&stream=false&show_border=false&locale=en_US", array( 'timeout' => 20 ) );
				$the_request = wp_remote_retrieve_body( $get_request );

				$pattern = '/_1drq[^>]+>(.*?)<\/a/s';
				$counter = penci_get_the_number( $pattern, $the_request );

				if ( ! empty( $counter ) ) { //To update the stored data
					$data['count'] = $counter;
					set_transient( 'penci_counter_facebook' . $page_id, $counter, $cache_period );
				}
			} elseif ( $facebook_count ) {
				$data['count'] = $facebook_count;
			}

			$data['url']  = "https://www.facebook.com/$page_id";
			$data['icon'] = penci_icon_by_ver( 'fab fa-facebook-f' );

			return $data;
		}
	}

endif;
